//CandibusPortIO.dll
#include <time.h>
#include <conio.h>
#include <windows.h>
#include "DlPortIO.h"


//Variables globales
unsigned int 	ADR1=0x280;          
unsigned int 	ADR2=0x282;          
unsigned int 	STATUS=0x284;
BOOL m_OKCarte=FALSE;

//________________________________________
//Prototypes -> Voir bk.def
BOOL Init(void);
BOOL OKCarte(void);
float LitTension(int NoVoie,int Nb);

void out_port(long a,unsigned char c);
unsigned char in_port(long a);
float readad(int NoVoie);


//________________________________________
//Corps
BOOL OKCarte(void)
{
	return m_OKCarte;
}
//________________________________________
BOOL Init(void)
{
	BOOL OK;
	if (GetVersion() & 0x80000000)
	{
		//W98
		OK=TRUE;
	}
	else
	{
		OK=TRUE;
	}
	if(OK)
	{
		float r;
		unsigned char c,c1,c2;
		double duree;
		clock_t t1,t2;
		if (GetVersion() & 0x80000000)
		{
			//W98
			r=readad(0);
			if (r==1e10)
				m_OKCarte=FALSE;
			else
				m_OKCarte=TRUE;
		}
		else
		{
			//W2000/XP : LitTension envoie toujours une valeur...
			out_port(ADR1,0xFF);
			t1=clock();
			do
			{
				t2=clock();
				duree=(double)(t2-t1)/CLOCKS_PER_SEC;	//Dure en secondes
				c=in_port(STATUS);
			}
			while((c&1) && duree<0.1);
			//c1=in_port(ADR1);
			//c2=in_port(ADR1+1);
			//CString s;s.Format("c:%d, c1%d, c2:%d",c,c1,c2);AfxMessageBox(s);
			//if (c1==255 && c2==255)
			if (duree>=0.1)
				m_OKCarte=FALSE;
			else
				m_OKCarte=TRUE;	
		}
	}
	else
		m_OKCarte=FALSE;
	
	return m_OKCarte;
}
//________________________________________
void out_port(long a,unsigned char c)
{
	if (GetVersion() & 0x80000000)
	{
		//Sous W98...
		//Registre de donnes: Offset+0: criture de l'octet
		_outp((unsigned short)a,c);
	}
	else
	{
		//DriverX pour XP
		//m_pCandi->outp(a-ADR1,c);
		//PortIO pour XP
	  DlPortWritePortUchar(a,c);
	}
}
//________________________________________
unsigned char in_port(long a)
{
	unsigned char k;
	if (GetVersion() & 0x80000000)
	{
		//Sous W98...
		k=_inp((unsigned short)a);
	}
	else
	{
		//DriverX pour XP : enlever l'adresse de base
		//k=m_pCandi->inp(a-ADR1);
		//PortIO pour XP
	  k=DlPortReadPortUchar(a);
	}
	return k;
}
//________________________________________
float readad(int NoVoie)
{
	float
		mesure1,mesure2;
	unsigned long i;	
	float r;
	double duree;
	clock_t t1,t2;

	switch(NoVoie)
	{
		case 0:
			out_port(ADR1,0xFF);
			t1=clock();
			do
			{
				t2=clock();
				duree=(double)(t2-t1)/CLOCKS_PER_SEC;	//Dure en secondes
			}
			while((in_port(STATUS)&1) && duree<0.1);
			if (duree<0.1)
			{
				//On dcale de 4 bits (voir notice page 6.4)
				mesure1=(float)(in_port(ADR1)<<4);
				mesure2=(float)(in_port(ADR1+1)>>4);
				r=(float)(10.24*(mesure1+mesure2-2047.5)/4094.0);
			}
			else
				r=1e10;
		break;
		case 1:
			out_port(ADR2,0xFF);
			t1=clock();
			do
			{
				t2=clock();
				duree=(double)(t2-t1)/CLOCKS_PER_SEC;
			}
			while((in_port(STATUS)&2) && duree<0.1);
			if (duree<0.1)
			{
				mesure1=(float)(in_port(ADR2)<<4);
				mesure2=(float)(in_port(ADR2+1)>>4);
				r=(float)(10.24*(mesure1+mesure2-2047.5)/4094.0);
			}
			else
				r=1e10;
		break;
	}
	return r;
}
//________________________________________
float LitTension(int NoVoie,int Nb)
{                                             
	int i,k;
	float r,r1;
	k=0;        
	r1=0;
	if (m_OKCarte)
	{
		for (i=0;i<Nb;i++)
		{   
			r=readad(NoVoie);
			if (r!=1e10)
			{       
				r1=r1+r;
				k++;
			}     
		}
		if (k>=1) return r1/k; else return 1e10;
	}
	else
		return 1e10;
}
